clc
clear all

seqdata = readtable('Global-India-01012020-11062020-29700-10664.csv', 'delimiter', ',', 'ReadVariableNames', false, 'HeaderLines', 0);

seqdata=table2cell(seqdata);
[r_seq,c_seq]=size(seqdata);
kval=3;
seqlength=10;
nmersVirusSeq=[];
%% finding the k length PAM
tempSeq=char(seqdata(1,4));
tempnmerSeq=nmercount(tempSeq,kval);%change kval
tempnmerSeqStr=join(string(tempnmerSeq(:,1))," ");
nmersVirusSeq=[nmersVirusSeq;tempnmerSeqStr];

 
 toknmersVirusSeq = tokenizedDocument(nmersVirusSeq);

 
  enc = wordEncoding(toknmersVirusSeq);

     
     
     

count_valnew=[];
for i=1:length(enc.Vocabulary)
    val=char(seqdata(1,4));
    count_val=strfind(val,enc.Vocabulary(1,i));
    seq_frequency{i,1}=length(count_val);
    seq{i,1}=enc.Vocabulary(1,i);
    count_val=[];
end

T1=table(seq,seq_frequency);


final_candidates=[seq seq_frequency];

%% finding the position of the PAMs in the reference sequence
final_candidates_sort=sortrows(final_candidates,2,'descend');
PAM_pos=zeros(length(final_candidates_sort),final_candidates_sort{1,2});
for i=1:length(final_candidates_sort)
    val1=char(final_candidates_sort{i,1});
    index_val_start_PAM=strfind(val,val1);
    len_index(i,1)=length(index_val_start_PAM);
    diffval=final_candidates_sort{1,2}-len_index(i,1);
    index_val_start_PAM(end+1:end+diffval)=0;
    PAM_pos(i,:)= index_val_start_PAM;
    index_val_start_PAM=[];
end
[r_p,c_p]=size(PAM_pos);
crispr_store={};
%% checking for palindromes corresponding to the PAMs
for i=1:r_p
    count_i=1;
    for j=1:c_p
        if(PAM_pos(i,j)>(seqlength+1))
            tocheck_end=PAM_pos(i,j)-1;
            tocheck_str=tocheck_end-(seqlength-1);
            crispr=extractBetween(val,tocheck_str,tocheck_end);
            crispr=cell2mat(crispr);
            comp_val=seqrcomplement(crispr);
            if (crispr == comp_val)
                crispr_store{count_i,i}=crispr;
                seq_store{count_i,i}=final_candidates_sort{i,1};
                pos_store_PAM{count_i,i}=PAM_pos(i,j);
                pos_store_crispr{count_i,i}=num2str(tocheck_str);
                count_i=count_i+1;
            end
        end
    end
end

[r_c,c_c]=size(crispr_store);

if(r_c~=0)
    count_crispr=0;
    for j=1:c_c
        for i=1:r_c
            TF=isempty(crispr_store{i,j});
            if(TF==0)
                if(any(diff(+crispr_store{i,j})))
                    tocheck_crispr=crispr_store{i,j};
                    tocheck_crispr_char=char(tocheck_crispr);
                    tocheck_crispr_pos=pos_store_crispr{i,j};
                    tocheck_PAM=seq_store{i,j};
                    tocheck_PAM_char=char(tocheck_PAM);
                    tocheck_PAM_pos=pos_store_PAM{i,j};
                    count_crispr=count_crispr+1;
                    final_result{count_crispr,1}=tocheck_crispr;
                    final_result{count_crispr,2}=tocheck_crispr_pos;
                    final_result{count_crispr,3}=tocheck_PAM;
                    final_result{count_crispr,4}=tocheck_PAM_pos;
                    for k=2:length(seqdata)
                        crispr_index=[];
                        PAM_index=[];
                        seqval=char(seqdata(k,4));
                        crispr_index=strfind(seqval,tocheck_crispr_char);
                        PAM_index=strfind(seqval,tocheck_PAM_char);
                        len_crispr_index(k-1,1)=length(crispr_index);
                         flag=[];
                         findval=0;
                        if(len_crispr_index(k-1,1)>=1)
                            for kkk=1:len_crispr_index(k-1,1)
                                findval=0;
                                PAM_val=crispr_index(1,kkk)+(seqlength+1);
                                if(PAM_val==0)
                                    PAM_pos_new(k-1,:)=0;
                                else
                                    for kk=1:length(PAM_index)
                                        if(PAM_index(1,kk)==PAM_val)
                                           PAM_pos_new(k-1,kkk)= PAM_index(1,kk); 
                                           flag(1,kkk)=1;
                                           findval=1;
                                        end
                                    end
                                    if(findval==0)
                                        flag(1,kkk)=0;
                                    end
                                end
                            end
                            
                            
                       else
                            PAM_pos_new(k-1,:)=0;
                        end
                        PAM_val=0;
                        
                        for kkk=1:len_crispr_index(k-1,1)
                            if(k==2 && len_crispr_index(k-1,1)==0)
                                PAM_pos_new(k-1,kkk)=0;
                                crispr_pos(k-1,kkk)= 0;
                            elseif(k==2 && len_crispr_index(k-1,1)>0 && flag(1,kkk)==1)
                                crispr_pos(k-1,kkk)= crispr_index(1,kkk);
                            elseif(k==2 && len_crispr_index(k-1,1)>0 && flag(1,kkk)==0)
                                PAM_pos_new(k-1,kkk)=0;
                                crispr_pos(k-1,kkk)= 0;   
                            elseif(k>2 && len_crispr_index(k-1,1)>0 && flag(1,kkk)==1)
                                if(len_crispr_index(k-1,1)<len_crispr_index(k-2,1))
                                    diffval_crispr=len_crispr_index(k-2,1)-len_crispr_index(k-1,1);
                                    crispr_index(end+1:end+diffval_crispr)=0;
                                end
                                crispr_pos(k-1,kkk)= crispr_index(1,kkk);
                            elseif(k>2 && len_crispr_index(k-1,1)>0 && flag(1,kkk)==0)
                                PAM_pos_new(k-1,kkk)=0;
                                crispr_pos(k-1,kkk)= 0;                    
                            elseif(k>2 && len_crispr_index(k-1,1)==0)
                                PAM_pos_new(k-1,:)=0;
                                crispr_pos(k-1,:)= 0;
                                crispr_index=[];                      
                                PAM_index=[];
                            end
                        end
                    end
                    
                end
                crispr_pos_new = crispr_pos(any(crispr_pos,2),:);
                PAM_pos_new1 = PAM_pos_new(any(PAM_pos_new,2),:);
      
                [r_cr,c_cr]=size(crispr_pos_new);
                final_result{count_crispr,6}=(r_cr/r_seq)*100;
                
                T3=table(crispr_pos_new,PAM_pos_new1);
                filename=['CRISPR/1stPaperUpdated_New/crisprPAM_allpositions_SARS2/crisprPAMallpositions_3_10_' num2str(count_crispr) '.csv'];
                writetable(T3,filename); 
                crispr_pos=[];
                PAM_pos_new=[];
                len_crispr_index=[];
                PAM_pos_new1=[];
                crispr_pos_new=[];
            end
            
            
        end
        
                           
        
    end
    final_result_1=[];
    if(count_crispr>0)
        [r_f,c_f]=size(final_result);
        for i=1:r_f
            final_result_2{i,1}=final_result{i,2};
        end

        for i=1:r_f

                    coord=final_result_2(i,1);
                    coord=cell2mat(coord);
                    coord=str2num(coord);
                if(1<=coord && coord<=265)%SARS-CoV-2
                    final_result{i,5}='5-Prime-UTR';
                elseif(266<=coord && coord<=805)
                    final_result{i,5}='NSP1';
                elseif(806<=coord && coord<=2719)
                    final_result{i,5}='NSP2';
                elseif(2720<=coord && coord<=8554)
                    final_result{i,5}='NSP3'; 
                elseif(8555<=coord && coord<=10054)
                    final_result{i,5}='NSP4';
                elseif(10055<=coord && coord<=10972)
                    final_result{i,5}='3CL-Proteinase';
                elseif(10973<=coord && coord<=11842)
                    final_result{i,5}='NSP6';
                elseif(11843<=coord && coord<=12091)
                    final_result{i,5}='NSP7';
                elseif(12092<=coord && coord<=12685)
                    final_result{i,5}='NSP8';
                elseif(12686<=coord && coord<=13024)
                    final_result{i,5}='NSP9';
                elseif(13025<=coord && coord<=13441)
                    final_result{i,5}='NSP10';
                elseif(13442<=coord && coord<=16236)
                    final_result{i,5}='RNA-dependent RNA polymerase';
                elseif(16237<=coord && coord<=18039)
                    final_result{i,5}='Helicase';
                elseif(18040<=coord && coord<=19620)
                    final_result{i,5}='Exon';    
                elseif(19621<=coord && coord<=20658)
                    final_result{i,5}='endoRNAse';
                elseif(20659<=coord && coord<=21512)
                    final_result{i,5}='2-O-methyltransferase';
                 elseif(21563<=coord && coord<=25385)
                    final_result{i,5}='Spike';
                elseif(25393<=coord && coord<=26221)
                    final_result{i,5}='ORF3a';    
                elseif(26245<=coord && coord<=26473)
                    final_result{i,5}='Envelope';
                elseif(26523<=coord && coord<=27192)
                    final_result{i,5}='Membrane';   
                elseif(27202<=coord && coord<=27388)
                    final_result{i,5}='ORF6';   
                elseif(27394<=coord && coord<=27760)
                    final_result{i,5}='ORF7a';   
                elseif(27756<=coord && coord<=27888)
                    final_result{i,5}='ORF7b';   
                elseif(27894<=coord && coord<=28260)
                    final_result{i,5}='ORF8';  
                elseif(28274<=coord && coord<=29534)
                    final_result{i,5}='Nucleocapsid'; 
                 elseif(29558<=coord && coord<=29675)
                    final_result{i,5}='ORF10'; 
                 elseif(coord>29675)
                    final_result{i,5}='3-Prime-UTR';
                 else
                    final_result{i,5}='Not Present';
                end
                         coord1=char(final_result(i,1));
                        lenval=length(coord1);
                        count_gc=0;
                        for ii=1:lenval
                            if(coord1(1,ii)=='G' || coord1(1,ii)=='C')
                                count_gc=count_gc+1;
                            end
                        end
                       final_result{i,7}=(count_gc/lenval)*100;
        end
        final_result=cell2table(final_result);
        filename=('crisprPAM_3_10.csv');
        writetable(final_result,filename,'WriteVariableNames',false); 


    end
end